#version 120

varying vec3 upVec;
varying vec3 sunVec;

varying vec4 texcoord;
varying vec4 lmcoord;
varying vec4 color;

uniform float rainStrength;

uniform sampler2D texture;

float Sun = pow(clamp(dot(sunVec,upVec)+0.1,0.0,0.1)/0.1,2.0);

void main(){

	vec4 albedo = vec4(0.0);
		 albedo.a = texture2D(texture, texcoord.xy).a;
	
	if(albedo.a > 0.01){
		albedo.rgb = texture2D(texture, texcoord.xy).rgb;
		albedo.a *= rainStrength * length(albedo.rgb/3)*float(albedo.a > 0.1);
		albedo.rgb = sqrt(albedo.rgb);
		albedo.rgb *= ((1.0-0.8*(1.0-Sun)*rainStrength) + lmcoord.x * lmcoord.x);
		
	}


/* DRAWBUFFERS:71 */

	gl_FragData[0] = albedo;
	gl_FragData[1] = vec4(lmcoord.x, 1.0, lmcoord.y, 1.0);
	
}