
#ifdef HighQualityShadows
//Higher quality offset, works great at higher filter values, more fps hungry
const vec2 shadowOffset[60] = vec2[60]  (  vec2( 0.0000, 0.2500 ),
								vec2( -0.2165, 0.1250 ),
								vec2( -0.2165, -0.1250 ),
								vec2( -0.0000, -0.2500 ),
								vec2( 0.2165, -0.1250 ),
								vec2( 0.2165, 0.1250 ),
								vec2( 0.0000, 0.5000 ),
								vec2( -0.2500, 0.4330 ),
								vec2( -0.4330, 0.2500 ),
								vec2( -0.5000, 0.0000 ),
								vec2( -0.4330, -0.2500 ),
								vec2( -0.2500, -0.4330 ),
								vec2( -0.0000, -0.5000 ),
								vec2( 0.2500, -0.4330 ),
								vec2( 0.4330, -0.2500 ),
								vec2( 0.5000, -0.0000 ),
								vec2( 0.4330, 0.2500 ),
								vec2( 0.2500, 0.4330 ),
								vec2( 0.0000, 0.7500 ),
								vec2( -0.2565, 0.7048 ),
								vec2( -0.4821, 0.5745 ),
								vec2( -0.6495, 0.3750 ),
								vec2( -0.7386, 0.1302 ),
								vec2( -0.7386, -0.1302 ),
								vec2( -0.6495, -0.3750 ),
								vec2( -0.4821, -0.5745 ),
								vec2( -0.2565, -0.7048 ),
								vec2( -0.0000, -0.7500 ),
								vec2( 0.2565, -0.7048 ),
								vec2( 0.4821, -0.5745 ),
								vec2( 0.6495, -0.3750 ),
								vec2( 0.7386, -0.1302 ),
								vec2( 0.7386, 0.1302 ),
								vec2( 0.6495, 0.3750 ),
								vec2( 0.4821, 0.5745 ),
								vec2( 0.2565, 0.7048 ),
								vec2( 0.0000, 1.0000 ),
								vec2( -0.2588, 0.9659 ),
								vec2( -0.5000, 0.8660 ),
								vec2( -0.7071, 0.7071 ),
								vec2( -0.8660, 0.5000 ),
								vec2( -0.9659, 0.2588 ),
								vec2( -1.0000, 0.0000 ),
								vec2( -0.9659, -0.2588 ),
								vec2( -0.8660, -0.5000 ),
								vec2( -0.7071, -0.7071 ),
								vec2( -0.5000, -0.8660 ),
								vec2( -0.2588, -0.9659 ),
								vec2( -0.0000, -1.0000 ),
								vec2( 0.2588, -0.9659 ),
								vec2( 0.5000, -0.8660 ),
								vec2( 0.7071, -0.7071 ),
								vec2( 0.8660, -0.5000 ),
								vec2( 0.9659, -0.2588 ),
								vec2( 1.0000, -0.0000 ),
								vec2( 0.9659, 0.2588 ),
								vec2( 0.8660, 0.5000 ),
								vec2( 0.7071, 0.7071 ),
								vec2( 0.5000, 0.8660 ),
								vec2( 0.2588, 0.9659 ));

#define shadowOffsetAmount 60.0

#else 

//Better performing shadow offset, doesn't work well at higher filter values	
const vec2 shadowOffset[9] = vec2[9](
							vec2(0.0,0.0),
							vec2(1.0,0.0),
							vec2(-1.0,0.0),
							vec2(0.0,1.0),
							vec2(0.0,-1.0),
							vec2(1.0,1.0) * 0.7,
							vec2(1.0,-1.0) * 0.7,
							vec2(-1.0,1.0) * 0.7,
							vec2(-1.0,-1.0) * 0.7);

#define shadowOffsetAmount 9.0

#endif

vec3 getShadow(float shadowDepth, vec3 normal, float stepSize, bool advDisFactor, bool isClamped){

	vec4 shadowPosition = biasedShadows(getShadowSpace(shadowDepth, texcoord.st));
	
	float NdotL = pow(clamp(dot(normal, lightVector),0.0,1.0),1.0);
	NdotL = mix(NdotL, 1.0, translucent);

	float step = 0.5 / shadowMapResolution;

	float distortFactor = getDistordFactor(shadowPosition);

	float diffthresh = pow(distortFactor, 4.0)/(4096 * 0.75) * tan(acos(max(NdotL,0.0))) + pow(max(length(fragpos),0.0),0.25) / 2048 * 0.2;
		diffthresh = mix(advDisFactor ? diffthresh : 0.0003 , 0.0003, translucent);

	vec3 shading = vec3(0.0);
	vec3 shading2 = vec3(0.0);
	vec3 colorShading = vec3(0.0);

	if (max(abs(shadowPosition.x),abs(shadowPosition.y)) < 0.99) {

	#ifdef ShadowFilter
	for (int i = 0; i < shadowOffsetAmount; i++) {

		shading += shadow2D(shadowtex1, vec3(shadowPosition.xy + shadowOffset[i] * step * stepSize, shadowPosition.z - diffthresh)).x;

		#ifdef ColoredShadows
			shading2 += shadow2D(shadowtex0, vec3(shadowPosition.xy + shadowOffset[i] * step * stepSize, shadowPosition.z - diffthresh)).x;
			colorShading += shadow2D(shadowcolor0, vec3(shadowPosition.xy + shadowOffset[i] * step * stepSize, shadowPosition.z - diffthresh)).rgb * 20.0;
		#endif
	}

	#else

		shading += shadow2D(shadowtex1, vec3(shadowPosition.xy, shadowPosition.z - diffthresh)).x;

		#ifdef ColoredShadows
			shading2 += shadow2D(shadowtex0, vec3(shadowPosition.xy, shadowPosition.z - diffthresh)).x;
			colorShading += shadow2D(shadowcolor0, vec3(shadowPosition.xy, shadowPosition.z - diffthresh)).rgb * 20.0;
		#endif

	#endif

	#ifdef ShadowFilter
		shading /= shadowOffsetAmount;
	#endif

	#ifdef ColoredShadows

		#ifdef ShadowFilter
			shading2 /= shadowOffsetAmount;
			colorShading /= shadowOffsetAmount;
		#endif

		shading = mix(shading2, colorShading, max(shading - shading2, 0.0));
	#endif

	}

	return isClamped ? vec3(clamp(shading,0.0, 1.0)) : shading;
}

