
//Controls intensity of different effects according to the biome the player is in

#define UniqueBiomes


#ifdef UniqueBiomes



uniform float isDesert;
uniform float isDefault;
uniform float isMesa;
uniform float isSnow;
uniform float isSwamp;
uniform float isJungle;
uniform float isBeach;

//Volumetric Clouds
	float DefaultCloud = 1.0 * isDefault;
    float SnowCloud = 0.55 * isSnow;
	float DesertCloud = 0.45 * isDesert;
	float MesaCloud = 0.45 * isMesa;
	float SwampCloud = 1.5 * isSwamp;
	float BeachCloud = 0.7 * isBeach;
	float JungleCloud = 0.8 * isJungle;

	float BiomeCloud = DefaultCloud + SnowCloud + DesertCloud + MesaCloud + SwampCloud + JungleCloud + BeachCloud;

//Volumetric Rain Clouds
	float DefaultRainCloud = 0.25 * isDefault;
    float SnowRainCloud = 0.45 * isSnow;
	float DesertRainCloud = 0.45 * isDesert;
	float MesaRainCloud = 0.45 * isMesa;
	float SwampRainCloud = 0.2 * isSwamp;
	float BeachRainCloud = 0.4 * isBeach;
	float JungleRainCloud = 0.42 * isJungle;

	float BiomeRainCloud = DefaultRainCloud + SnowRainCloud + DesertRainCloud + MesaRainCloud + SwampRainCloud + JungleRainCloud + BeachRainCloud;


//Rain Drops on Screen

	float DefaultRainDrops = 1.0 * isDefault;
    float SnowRainDrops = 0.0 * isSnow;
	float DesertRainDrops = 0.0 * isDesert;
	float MesaRainDrops = 0.0 * isMesa;
	float SwampRainDrops = 1.0 * isSwamp;
	float BeachRainDrops = 1.0 * isBeach;
	float JungleRainDrops = 1.0 * isJungle;

	float BiomeRainDrops = DefaultRainDrops + SnowRainDrops + DesertRainDrops + MesaRainDrops + SwampRainDrops + JungleRainDrops + BeachRainDrops;

//Controls weather colouring 

	float DefaultRainColor = 0.0 * isDefault;
    float SnowRainColor = 0.0 * isSnow;
	float DesertRainColor = 0.0 * isDesert;
	float MesaRainColor = 0.0 * isMesa;
	float SwampRainColor = 1.0 * isSwamp;
	float BeachRainColor = 0.0 * isBeach;
	float JungleRainColor = 0.0 * isJungle;

	float BiomeRainColor = DefaultRainColor + SnowRainColor + DesertRainColor + MesaRainColor + SwampRainColor + JungleRainColor + BeachRainColor;

//Waving speeds

	float DefaultWaving = 0.7 * isDefault;
    float SnowWaving = 0.35 * isSnow;
	float DesertWaving = 0.2 * isDesert;
	float MesaWaving = 0.2 * isMesa;
	float SwampWaving = 1.0 * isSwamp;
	float BeachWaving = 1.0 * isBeach;
	float JungleWaving = 1.0 * isJungle;

	float BiomeWaving = DefaultWaving + SnowWaving + DesertWaving + MesaWaving + SwampWaving + JungleWaving + BeachWaving;

//Shadow Filter

	float DefaultShadow = 1.0 * isDefault;
    float SnowShadow = 1.35 * isSnow;
	float DesertShadow = 0.75 * isDesert;
	float MesaShadow = 0.75 * isMesa;
	float SwampShadow = 1.15 * isSwamp;
	float BeachShadow = 0.85 * isBeach;
	float JungleShadow = 1.0 * isJungle;

	float BiomeShadow = DefaultShadow + SnowShadow + DesertShadow + MesaShadow + SwampShadow + JungleShadow + BeachShadow;

//Volumetric Light Sunrise/Sunset
	float DefaultLightS = 1.0 * isDefault;
    float SnowLightS = 1.45 * isSnow;
	float DesertLightS = 0.3 * isDesert;
	float MesaLightS = 0.3 * isMesa;
	float SwampLightS = 1.35 * isSwamp;
	float BeachLightS = 1.0 * isBeach;
	float JungleLightS = 1.35 * isJungle;

	float BiomeLightS = DefaultLightS + SnowLightS + DesertLightS + MesaLightS + SwampLightS + JungleLightS + BeachLightS;


//Volumetric Light Day
	float DefaultLightD = 1.0 * isDefault;
    float SnowLightD = 1.45 * isSnow;
	float DesertLightD = 0.3 * isDesert;
	float MesaLightD = 0.3 * isMesa;
	float SwampLightD = 1.55 * isSwamp;
	float BeachLightD = 1.0 * isBeach;
	float JungleLightD = 1.35 * isJungle;

	float BiomeLightD = DefaultLightD + SnowLightD + DesertLightD + MesaLightD + SwampLightD + JungleLightD + BeachLightD;


//Volumetric Light Night
	float DefaultLightN = 1.0 * isDefault;
    float SnowLightN = 1.45 * isSnow;
	float DesertLightN = 0.3 * isDesert;
	float MesaLightN = 0.3 * isMesa;
	float SwampLightN = 1.5 * isSwamp;
	float BeachLightN = 1.0 * isBeach;
	float JungleLightN = 2.0 * isJungle;

	float BiomeLightN = DefaultLightN + SnowLightN + DesertLightN + MesaLightN + SwampLightN + JungleLightN + BeachLightN;
	

//Fog Multiplier

	float DefaultFog = 1.0 * isDefault;
    float SnowFog = 1.35 * isSnow;
	float DesertFog = 0.5 * isDesert;
	float MesaFog = 0.5 * isMesa;
	float SwampFog = 1.35 * isSwamp;
	float BeachFog = 1.0 * isBeach;
	float JungleFog = 0.7 * isJungle;

	float BiomeFog = DefaultFog + SnowFog + DesertFog + MesaFog + SwampFog + JungleFog + BeachFog;

#else



	float BiomeCloud = 1.0;
	float BiomeRainCloud = 0.3;
	float BiomeLightS = 1.0;
	float BiomeLightD = 1.0;
	float BiomeLightN = 1.0;
	float BiomeRainDrops = 1.0;
	float BiomeFog = 1.0;
	float BiomeRainColor = 1.0;
	float BiomeWaving = 1.0;
	float BiomeShadow = 1.0;

	float SwampRainColor = 1.0;



#endif



#ifdef UniqueBiomes

//Weather Swamp
#define WeatherSwampR 200 
#define WeatherSwampG 224 
#define WeatherSwampB 160 
#define WeatherSwampS 1.00 
#define WeatherSwamp vec3(WeatherSwampR,WeatherSwampG,WeatherSwampB)/255.0
vec3 weather_Swamp = (WeatherSwamp*WeatherSwamp*WeatherSwampS) * BiomeRainColor;

#else 

vec3 weather_Swamp = vec3(0.0);

#endif